<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.scripts_select.c_compute_chi2.run_stats_all &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../../" id="documentation_options" src="../../../../../_static/documentation_options.js"></script>
        <script src="../../../../../_static/jquery.js"></script>
        <script src="../../../../../_static/underscore.js"></script>
        <script src="../../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../../_static/doctools.js"></script>
    <script src="../../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.scripts_select.c_compute_chi2.run_stats_all</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.scripts_select.c_compute_chi2.run_stats_all</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Analyse how the reduced chi2 evolves as a function of how multiple</span>
<span class="sd">candidates are handled, by producing a table listing all the reduced</span>
<span class="sd">:math:`\\chi^2` values.</span>

<span class="sd">To produce the tables, just run</span>

<span class="sd">.. code-block::</span>

<span class="sd">    python run.py (-o {outdir})</span>

<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>
<span class="kn">import</span> <span class="nn">config</span>

<span class="kn">from</span> <span class="nn">uncertainties</span> <span class="kn">import</span> <span class="n">unumpy</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="kn">from</span> <span class="nn">lib.inout.serial</span> <span class="kn">import</span> <span class="n">load_json</span><span class="p">,</span> <span class="n">load_pickle</span>
<span class="kn">from</span> <span class="nn">lib.inout.table</span> <span class="kn">import</span> <span class="n">write_table</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_array</span> <span class="kn">import</span> <span class="n">compute_weighted_avg</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_str</span> <span class="kn">import</span> <span class="n">turn_into_latex_friendly</span>

<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">paths</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.definition.strategy</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">list_all_full_muc_strats</span>
<span class="p">)</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.mulcan.parser</span> <span class="kn">import</span> <span class="n">get_result_gen_parser</span>


<div class="viewcode-block" id="fmt_val"><a class="viewcode-back" href="../../../../../scripts.multiple_candidates.scripts_select.c_compute_chi2.html#scripts.multiple_candidates.scripts_select.c_compute_chi2.run_stats_all.fmt_val">[docs]</a><span class="k">def</span> <span class="nf">fmt_val</span><span class="p">(</span><span class="n">val</span><span class="p">:</span> <span class="nb">float</span><span class="p">):</span>
    <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{val:.2f}</span><span class="s2">&quot;</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="c1"># PARSER ===============================================================</span>
    <span class="n">outdir</span> <span class="o">=</span> <span class="n">get_result_gen_parser</span><span class="p">(</span>
        <span class="n">description</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;Analyse how the reduced chi2 evolves depending on &quot;</span>
                     <span class="s2">&quot;how multiple candidates are handled&quot;</span><span class="p">),</span>
        <span class="n">list_arguments</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;outdir&quot;</span><span class="p">]</span>
    <span class="p">)</span>
    <span class="n">table_dir</span> <span class="o">=</span> <span class="n">config</span><span class="o">.</span><span class="n">table_dir_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">outdir</span><span class="o">=</span><span class="n">outdir</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;LOAD ALL REDUCED CHI2&quot;</span><span class="p">)</span>
    <span class="n">dict_all_chi2</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="n">dict_all_avg_chi2</span> <span class="o">=</span> <span class="p">{}</span>

    <span class="k">for</span> <span class="n">full_muc_strat</span> <span class="ow">in</span> <span class="n">list_all_full_muc_strats</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">ffmod</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FFMODELS</span><span class="p">:</span>
            <span class="n">format_values</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span>
                <span class="n">ffmodel</span><span class="o">=</span><span class="n">ffmod</span><span class="p">,</span> <span class="n">outdir</span><span class="o">=</span><span class="n">outdir</span><span class="p">,</span> <span class="n">full_muc_strat</span><span class="o">=</span><span class="n">full_muc_strat</span>
            <span class="p">)</span>

            <span class="k">for</span> <span class="n">year</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_YEARS</span><span class="p">:</span>
                <span class="n">dict_all_chi2</span><span class="p">[</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmod</span><span class="p">,</span> <span class="n">year</span><span class="p">]</span> <span class="o">=</span> \
                    <span class="n">load_json</span><span class="p">(</span>
                        <span class="n">path</span><span class="o">=</span><span class="n">config</span><span class="o">.</span><span class="n">json_path_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                            <span class="n">year</span><span class="o">=</span><span class="n">year</span><span class="p">,</span> <span class="o">**</span><span class="n">format_values</span><span class="p">)</span>
                <span class="p">)</span>

            <span class="n">dict_rdstar</span> <span class="o">=</span> <span class="n">load_pickle</span><span class="p">(</span>
                <span class="n">path</span><span class="o">=</span><span class="n">config</span><span class="o">.</span><span class="n">rdstar_pickle_path_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                    <span class="o">**</span><span class="n">format_values</span><span class="p">)</span>
            <span class="p">)</span>
            <span class="n">array_err</span> <span class="o">=</span> <span class="n">unumpy</span><span class="o">.</span><span class="n">std_devs</span><span class="p">([</span>
                <span class="n">dict_rdstar</span><span class="p">[</span><span class="n">year</span><span class="p">]</span>
                <span class="k">for</span> <span class="n">year</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_YEARS</span>
            <span class="p">])</span>

            <span class="n">dict_all_avg_chi2</span><span class="p">[</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmod</span><span class="p">]</span> <span class="o">=</span> <span class="n">compute_weighted_avg</span><span class="p">(</span>
                <span class="p">[</span><span class="n">dict_all_chi2</span><span class="p">[</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmod</span><span class="p">,</span> <span class="n">year</span><span class="p">][</span><span class="s2">&quot;tot_reduced_chi2&quot;</span><span class="p">]</span>
                    <span class="k">for</span> <span class="n">year</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_YEARS</span><span class="p">],</span>
                <span class="n">weights</span><span class="o">=</span><span class="mi">1</span> <span class="o">/</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">square</span><span class="p">(</span><span class="n">array_err</span><span class="p">))</span>
            <span class="p">)</span>

    <span class="k">def</span> <span class="nf">get_dict_chi2</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmodel</span><span class="p">,</span> <span class="n">year</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">dict_all_chi2</span><span class="p">[</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmodel</span><span class="p">,</span> <span class="n">year</span><span class="p">]</span>

    <span class="k">def</span> <span class="nf">get_avg_chi2</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmodel</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">dict_all_avg_chi2</span><span class="p">[</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmodel</span><span class="p">]</span>

    <span class="c1"># ONE TABLE / full_muc_strat =============================================</span>
    <span class="n">list_loops</span> <span class="o">=</span> <span class="p">[</span>
        <span class="p">[</span><span class="s2">&quot;full_muc_strat&quot;</span><span class="p">,</span> <span class="s2">&quot;ffmodel&quot;</span><span class="p">],</span>
        <span class="p">[</span><span class="s2">&quot;ffmodel&quot;</span><span class="p">,</span> <span class="s2">&quot;full_muc_strat&quot;</span><span class="p">],</span>
    <span class="p">]</span>
    <span class="n">list_table_names_wildcards</span> <span class="o">=</span> <span class="p">[</span>
        <span class="n">config</span><span class="o">.</span><span class="n">table_name_full_muc_strat_wildcards</span><span class="p">,</span>
        <span class="n">config</span><span class="o">.</span><span class="n">table_name_ffmodel_wildcards</span>
    <span class="p">]</span>
    <span class="n">dict_values</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;full_muc_strat&quot;</span><span class="p">:</span> <span class="n">list_all_full_muc_strats</span><span class="p">,</span>
        <span class="s2">&quot;ffmodel&quot;</span><span class="p">:</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FFMODELS</span><span class="p">,</span>
    <span class="p">}</span>

    <span class="k">for</span> <span class="n">loop</span><span class="p">,</span> <span class="n">table_name_wildcards</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">list_loops</span><span class="p">,</span>
                                          <span class="n">list_table_names_wildcards</span><span class="p">):</span>
        <span class="n">table_name</span> <span class="o">=</span> <span class="n">loop</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">col_name</span> <span class="o">=</span> <span class="n">loop</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>

        <span class="k">for</span> <span class="n">table_val</span> <span class="ow">in</span> <span class="n">dict_values</span><span class="p">[</span><span class="n">table_name</span><span class="p">]:</span>
            <span class="n">table_val_label</span> <span class="o">=</span> <span class="n">config</span><span class="o">.</span><span class="n">dict_value_labels</span><span class="p">[</span><span class="n">table_name</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
                <span class="n">table_val</span><span class="p">,</span> <span class="n">turn_into_latex_friendly</span><span class="p">(</span><span class="n">table_val</span><span class="p">))</span>
            <span class="n">first_row</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Year&quot;</span><span class="p">]</span>
            <span class="n">first_row</span> <span class="o">+=</span> <span class="p">[</span>
                <span class="n">config</span><span class="o">.</span><span class="n">dict_value_labels</span><span class="p">[</span><span class="n">col_name</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
                    <span class="n">col_val</span><span class="p">,</span> <span class="n">turn_into_latex_friendly</span><span class="p">(</span><span class="n">col_val</span><span class="p">))</span>
                <span class="k">for</span> <span class="n">col_val</span> <span class="ow">in</span> <span class="n">dict_values</span><span class="p">[</span><span class="n">col_name</span><span class="p">]</span>
            <span class="p">]</span>
            <span class="n">first_row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;Average&quot;</span><span class="p">)</span>
            <span class="n">table</span> <span class="o">=</span> <span class="p">[</span><span class="n">first_row</span><span class="p">]</span>

            <span class="k">for</span> <span class="n">year</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_YEARS</span><span class="p">:</span>
                <span class="n">row</span> <span class="o">=</span> <span class="p">[</span><span class="n">year</span><span class="p">]</span>
                <span class="n">list_chi2_row</span> <span class="o">=</span> <span class="p">[]</span>
                <span class="k">for</span> <span class="n">col_val</span> <span class="ow">in</span> <span class="n">dict_values</span><span class="p">[</span><span class="n">col_name</span><span class="p">]:</span>
                    <span class="n">dict_chi2</span> <span class="o">=</span> <span class="n">get_dict_chi2</span><span class="p">(</span>
                        <span class="o">**</span><span class="p">{</span>
                            <span class="n">table_name</span><span class="p">:</span> <span class="n">table_val</span><span class="p">,</span>
                            <span class="s2">&quot;year&quot;</span><span class="p">:</span> <span class="n">year</span><span class="p">,</span>
                            <span class="n">col_name</span><span class="p">:</span> <span class="n">col_val</span>
                        <span class="p">}</span>
                    <span class="p">)</span>
                    <span class="n">list_red_chi2</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dict_chi2</span><span class="p">[</span><span class="s2">&quot;reduced_chi2&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>
                    <span class="n">sum_red_chi2</span> <span class="o">=</span> <span class="n">dict_chi2</span><span class="p">[</span><span class="s2">&quot;tot_reduced_chi2&quot;</span><span class="p">]</span>
                    <span class="n">row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
                        <span class="s2">&quot; + &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">fmt_val</span><span class="p">(</span><span class="n">chi2</span><span class="p">)</span> <span class="k">for</span> <span class="n">chi2</span> <span class="ow">in</span> <span class="n">list_red_chi2</span><span class="p">])</span>
                        <span class="o">+</span> <span class="sa">f</span><span class="s2">&quot; = {fmt_val(sum_red_chi2)}&quot;</span>
                    <span class="p">)</span>
                    <span class="n">list_chi2_row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sum_red_chi2</span><span class="p">)</span>
                <span class="n">row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">list_chi2_row</span><span class="p">))</span>
                <span class="n">table</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">row</span><span class="p">)</span>

            <span class="n">last_row</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Average&quot;</span><span class="p">]</span>
            <span class="n">list_chi2_all_years</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">col_val</span> <span class="ow">in</span> <span class="n">dict_values</span><span class="p">[</span><span class="n">col_name</span><span class="p">]:</span>
                <span class="n">avg_chi2</span> <span class="o">=</span> <span class="n">get_avg_chi2</span><span class="p">(</span>
                    <span class="o">**</span><span class="p">{</span>
                        <span class="n">table_name</span><span class="p">:</span> <span class="n">table_val</span><span class="p">,</span>
                        <span class="n">col_name</span><span class="p">:</span> <span class="n">col_val</span>
                    <span class="p">}</span>
                <span class="p">)</span>
                <span class="n">last_row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fmt_val</span><span class="p">(</span><span class="n">avg_chi2</span><span class="p">))</span>
                <span class="n">list_chi2_all_years</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">avg_chi2</span><span class="p">)</span>
            <span class="n">last_row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fmt_val</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">list_chi2_all_years</span><span class="p">)))</span>
            <span class="n">table</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">last_row</span><span class="p">)</span>

            <span class="n">write_table</span><span class="p">(</span>
                <span class="n">table</span><span class="o">=</span><span class="n">table</span><span class="p">,</span>
                <span class="n">path</span><span class="o">=</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">table_dir</span><span class="p">,</span> <span class="n">table_name_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                    <span class="o">**</span><span class="p">{</span><span class="n">table_name</span><span class="p">:</span> <span class="n">table_val</span><span class="p">})),</span>
                <span class="n">caption</span><span class="o">=</span><span class="sa">r</span><span class="s2">&quot;Reduced $\chi^2$ for &quot;</span> <span class="o">+</span> <span class="n">table_val_label</span>
            <span class="p">)</span>

    <span class="c1"># AVERAGED-CHI2 TABLE ==================================================</span>
    <span class="n">table</span> <span class="o">=</span> <span class="p">[</span>
        <span class="p">[</span><span class="n">config</span><span class="o">.</span><span class="n">dict_labels</span><span class="p">[</span><span class="s2">&quot;full_muc_strat&quot;</span><span class="p">]]</span>
        <span class="o">+</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FFMODELS</span> <span class="o">+</span> <span class="p">[</span><span class="s2">&quot;Average&quot;</span><span class="p">]</span>
    <span class="p">]</span>

    <span class="k">for</span> <span class="n">full_muc_strat</span> <span class="ow">in</span> <span class="n">list_all_full_muc_strats</span><span class="p">:</span>
        <span class="n">row</span> <span class="o">=</span> <span class="p">[</span><span class="n">config</span><span class="o">.</span><span class="n">dict_value_labels</span><span class="p">[</span><span class="s2">&quot;full_muc_strat&quot;</span><span class="p">][</span><span class="n">full_muc_strat</span><span class="p">]]</span>
        <span class="n">list_chi2_full_muc_strat</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">ffmodel</span> <span class="ow">in</span> <span class="n">paths</span><span class="o">.</span><span class="n">LIST_FFMODELS</span><span class="p">:</span>
            <span class="n">avg_chi2</span> <span class="o">=</span> <span class="n">get_avg_chi2</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="n">ffmodel</span><span class="p">)</span>
            <span class="n">row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fmt_val</span><span class="p">(</span><span class="n">avg_chi2</span><span class="p">))</span>
            <span class="n">list_chi2_full_muc_strat</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">avg_chi2</span><span class="p">)</span>
        <span class="n">row</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fmt_val</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">list_chi2_full_muc_strat</span><span class="p">)))</span>
        <span class="n">table</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">row</span><span class="p">)</span>
    <span class="n">write_table</span><span class="p">(</span>
        <span class="n">table</span><span class="o">=</span><span class="n">table</span><span class="p">,</span>
        <span class="n">path</span><span class="o">=</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">table_dir</span><span class="p">,</span> <span class="n">config</span><span class="o">.</span><span class="n">table_name_avg</span><span class="p">),</span>
        <span class="n">caption</span><span class="o">=</span><span class="s2">&quot;Year-averaged reduced $</span><span class="se">\\</span><span class="s2">chi^2$&quot;</span>
    <span class="p">)</span>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>